﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace Win
{
    class log
    {
        private string m_fileName; // 文件名
        private string m_filePath; // 文件路径

        public string FileFullPath
        {
            get
            {
                if (Directory.Exists(m_filePath) == false)
                {
                    Directory.CreateDirectory(m_filePath);
                }
                return m_filePath.TrimEnd('/') + "/" + m_fileName;
            }

        }

        public void Log()
        {
            m_fileName = DateTime.Now.ToString("yyyy-MM-dd") + ".txt"; // 默认文件名为 今天的日期
            m_filePath = AppDomain.CurrentDomain.BaseDirectory + "/log";  // 默认路径在当前域log文件夹下面     
        }
        public void Log(string sFileName)
        {
            m_fileName = sFileName;
            m_filePath = AppDomain.CurrentDomain.BaseDirectory + "/log";  //默认路径在当前域log文件夹下面 
        }

        public void Write(string message)
        {
            WriteLine(message);
        }

        public void WriteLine(string message)
        {
            WriteLine(null, message);
        }


        /// <summary>
        /// 将异常或信息写入日志
        /// </summary>
        /// <param name="exception"></param>
        /// <param name="message"></param>
        public void WriteLine(object exception, string message)
        {
            string sMsg = Environment.NewLine + DateTime.Now.ToString() + Environment.NewLine;
            if (!string.IsNullOrEmpty(message))  //如果信息不为空，加在最前面
            {
                sMsg += message;
            }
            if (exception is Exception)
            {
                Exception ex = (Exception)exception;
                sMsg += ex.Message + Environment.NewLine; // 错误提示
                sMsg += ex.StackTrace;  // 堆栈信息
            }
            else if (exception != null)
            {
                sMsg += exception.ToString();
            }


            File.AppendAllText(FileFullPath, sMsg);
            File.AppendAllText(FileFullPath, " " + "\r\n");
        }

    }
}
